import pyffle
import processor
from pyffleutil import recompile
from traceback import format_exc

def getprocessor(bname):
	blower = bname.lower()
	bpath = "processor."+blower
	if bname == "Default":
		bclassname = "Processor"
	else:
		bclassname = bname + "Processor"
	pyffle.debug("getprocessor - bname="+bname+" bpath="+bpath)
	try:
		recompile(bpath)
	except:
		pyffle.debug("getprocessor - unable to recompile: "+bpath+" exception: "+format_exc())
		return None

	try:
		__import__(bpath)
	except:
		pyffle.debug("getprocessor - unable to import: "+bpath+" exception: "+format_exc())
		return None

	try:
		processormod = getattr(processor,blower)
	except:
		pyffle.debug("getprocessor - no attribute on processor named: "+blower+" exception: "+format_exc())
		return None

	try:
		processorclass = getattr(processormod,bclassname)
	except:
		pyffle.debug("getprocessor - module "+bpath+" didn't contain a class "+bclassname+" exception: "+format_exc())
		return None
	try:
		bobj = processorclass()
	except:
		pyffle.debug("getprocessor - unable to instantiate object for module: "+bpath+" class: "+bclassname+" exception: "+format_exc())
		return None
	return bobj
